
class vect {
	int *p;
	int size;
public:
	int ub;							// upper bound = size-1
	vect(int n=10);					// konstruktor z domniemanym argumentem
	vect(const vect &v);			// konstruktor kopiujcy
	~vect() { delete p; }			// destruktor
	vect& operator =(const vect &v);// operator podstawiania
	int operator ==(const vect &v) const;	// porwnanie wektorw
	int& operator[](int i);			// operator indeksowy
	vect operator+(const vect &v) const;	// dodawanie wektorw
	vect operator-(const vect &v) const;	// odejmowanie wektorw
	int operator*(const vect &v) const;		// iloczyn skalarny
	vect operator*(int a) const;			// mnoenie wektora przez skalar
	void operator !() const;				// print
};

vect::vect(int n)
{
	if(n<=0) exit(1);	// "fatal error" mona by powiedzie...
	size=n;
	p=new int[size];
	ub=size-1;		// Okrelenie maksymalnej wartoci indeksu
}

vect::vect(const vect &v)
{
    p=0;
    *this=v;
}

vect& vect::operator =(const vect &v)
{
	size=v.size;
	if(p) delete p;
	p=new int[size];
	ub=size-1;		// Okrelenie maksymalnej wartoci indeksu
	for(int i=0;i<size;i++)
		p[i]=v.p[i];
	return *this;
}

int vect::operator ==(const vect &v) const
{
	if(size!=v.size)
		return 0;		// inny wymiar
	for(int i=0;i<size;i++)
		if(p[i]!=v.p[i])
			return 0;	// rne elementy
}

int& vect::operator[](int i)
{
	if(i<0||i>ub) exit(1);
	return(p[i]);
}

vect vect::operator+(const vect &v) const
{
	int s=size>v.size? size:v.size;
	vect temp(s);
	for(int i=0;i<s;i++)
		temp[i]=p[i]+v.p[i];
	return temp;
}

vect vect::operator-(const vect &v) const
{
	int s=size>v.size? size:v.size;
	vect temp(s);
	for(int i=0;i<s;i++)
		temp[i]=p[i]-v.p[i];
	return temp;
}

int vect::operator*(const vect &v) const
{
	int s=size<v.size? size:v.size;
	int i_sk=0;
	for(int i=0;i<s;i++)
		i_sk+=p[i]*v.p[i];
	return i_sk;
}

vect vect::operator*(int a) const
{
	vect temp(*this);
	for(int i=0;i<size;i++)
		temp[i]*=a;
	return temp;
}

vect operator*(int a, const vect &v)
{
	return v*a;
}

void vect::operator !() const
{
	for(int i=0;i<size;i++)
		cout << endl << p[i];
}

void main(void)
{
	const n=3;
	vect a(n),b(n),c(n);
	for(int i=0;i<n;i++)
		a[i]=i*2+3;
	for(i=0;i<n;i++)
		b[i]=10-i;
	c=2*a-b;
	cout << "\nWektor a:\n"; !a;
	cout << "\nWektor b:\n"; !b;
	cout << "\nWektor c=2*a-b:\n"; !c;
	cout << "\n\na*b = " << a*b;
	getch();
}
